// -*- c++ -*-
// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _GSTREAMERMM_PLUGINFEATURE_H
#define _GSTREAMERMM_PLUGINFEATURE_H


#include <glibmm.h>

/* gstreamermm - a C++ wrapper for gstreamer
 *
 * Copyright 2008 The gstreamermm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <gst/gstpluginfeature.h>
#include <gstreamermm/object.h>


#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _GstPluginFeature GstPluginFeature;
typedef struct _GstPluginFeatureClass GstPluginFeatureClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Gst
{ class PluginFeature_Class; } // namespace Gst
namespace Gst
{

/** @addtogroup gstreamermmEnums Enums and Flags */

/**
 * @ingroup gstreamermmEnums
 */
enum Rank
{
  RANK_NONE = 0,
  RANK_MARGINAL = 64,
  RANK_SECONDARY = 128,
  RANK_PRIMARY = 256
};

} // namespace Gst


#ifndef DOXYGEN_SHOULD_SKIP_THIS
namespace Glib
{

template <>
class Value<Gst::Rank> : public Glib::Value_Enum<Gst::Rank>
{
public:
  static GType value_type() G_GNUC_CONST;
};

} // namespace Glib
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Gst
{


/** This is a base class for anything that can be added to a Gst::Plugin.
 *
 */

class PluginFeature : public Object
{
  
#ifndef DOXYGEN_SHOULD_SKIP_THIS

public:
  typedef PluginFeature CppObjectType;
  typedef PluginFeature_Class CppClassType;
  typedef GstPluginFeature BaseObjectType;
  typedef GstPluginFeatureClass BaseClassType;

private:  friend class PluginFeature_Class;
  static CppClassType pluginfeature_class_;

private:
  // noncopyable
  PluginFeature(const PluginFeature&);
  PluginFeature& operator=(const PluginFeature&);

protected:
  explicit PluginFeature(const Glib::ConstructParams& construct_params);
  explicit PluginFeature(GstPluginFeature* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
  virtual ~PluginFeature();

#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type()      G_GNUC_CONST;


  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GObject.
  GstPluginFeature*       gobj()       { return reinterpret_cast<GstPluginFeature*>(gobject_); }

  ///Provides access to the underlying C GObject.
  const GstPluginFeature* gobj() const { return reinterpret_cast<GstPluginFeature*>(gobject_); }

  ///Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
  GstPluginFeature* gobj_copy();

private:


public:
  /** For example,
   * bool on_filter(const Glib::RefPtr<Gst::PluginFeature>& feature);.
   * The filter function should return true if the feature is a match, false
   * otherwise.
   */
  typedef sigc::slot< bool, const Glib::RefPtr<Gst::PluginFeature>& > SlotFilter;

  
  /** Specifies a rank for a plugin feature, so that autoplugging uses
   * the most appropriate feature.
   * @param rank Rank value - higher number means more priority rank.
   */
  void set_rank(guint rank);
  
  /** Sets the name of a plugin feature. The name uniquely identifies a feature
   * within all features of the same type. Renaming a plugin feature is not
   * allowed. A copy is made of the name so you should free the supplied @a name
   * after calling this function.
   * @param name The name to set.
   */
  void set_name(const Glib::ustring& name);
  
  /** Gets the rank of a plugin feature.
   * @return The rank of the feature.
   */
  guint get_rank() const;
  
  /** Gets the name of a plugin feature.
   * @return The name.
   */
  Glib::ustring get_name() const;
  
  /** Loads the plugin containing @a feature if it's not already loaded. @a feature is
   * unaffected; use the return value instead.
   * 
   * Normally this function is used like this:
   * |[
   * GstPluginFeature *loaded_feature;
   * 
   * loaded_feature = gst_plugin_feature_load (feature);
   * // presumably, we're no longer interested in the potentially-unloaded feature
   * gst_object_unref (feature);
   * feature = loaded_feature;
   * ]|
   * @return A reference to the loaded feature, or <tt>0</tt> on error.
   */
  Glib::RefPtr<Gst::PluginFeature> load();

  // Don't wrap gst_plugin_feature_list_free because Glib::ListHandle<> handles
  // list freeing already.
  

  /** Checks whether the given plugin feature is at least
   * the required version
   * @param min_major Minimum required major version.
   * @param min_minor Minimum required minor version.
   * @param min_micro Minimum required micro version.
   * @return #<tt>true</tt> if the plugin feature has at least
   * the required version, otherwise #<tt>false</tt>.
   */
  bool check_version(guint min_major, guint min_minor, guint min_micro) const;

  //gst_plugin_feature_type_name_filter is a C API convenience function which
  //tells if a plugin feature has a name and a type so ignore it.
  

public:

public:
  //C++ methods used to invoke GTK+ virtual functions:
#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

protected:
  //GTK+ Virtual Functions (override these to change behaviour):
#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

  //Default Signal Handlers::
#ifdef GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED
#endif //GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED


};

} // namespace Gst


namespace Glib
{
  /** A Glib::wrap() method for this object.
   * 
   * @param object The C instance.
   * @param take_copy False if the result should take ownership of the C instance. True if it should take a new copy or ref.
   * @result A C++ instance that wraps this C instance.
   *
   * @relates Gst::PluginFeature
   */
  Glib::RefPtr<Gst::PluginFeature> wrap(GstPluginFeature* object, bool take_copy = false);
}


#endif /* _GSTREAMERMM_PLUGINFEATURE_H */

