// -*- c++ -*-
// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _GSTREAMERMM_TASKPOOL_H
#define _GSTREAMERMM_TASKPOOL_H


#include <glibmm.h>

/* gstreamermm - a C++ wrapper for gstreamer
 *
 * Copyright 2008-2009 The gstreamermm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <gst/gsttaskpool.h>
#include <gstreamermm/object.h>


#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _GstTaskPool GstTaskPool;
typedef struct _GstTaskPoolClass GstTaskPoolClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Gst
{ class TaskPool_Class; } // namespace Gst
namespace Gst
{

/** Gst::TaskPool - Pool of GStreamer streaming threads.
 * This object provides an abstraction for creating threads. The default
 * implementation uses a regular Glib::ThreadPool to start tasks.
 *
 * Subclasses can be made to create custom threads.
 *
 * Last reviewed on 2009-04-23 (0.10.24)
 */

class TaskPool : public Object
{
  
#ifndef DOXYGEN_SHOULD_SKIP_THIS

public:
  typedef TaskPool CppObjectType;
  typedef TaskPool_Class CppClassType;
  typedef GstTaskPool BaseObjectType;
  typedef GstTaskPoolClass BaseClassType;

private:  friend class TaskPool_Class;
  static CppClassType taskpool_class_;

private:
  // noncopyable
  TaskPool(const TaskPool&);
  TaskPool& operator=(const TaskPool&);

protected:
  explicit TaskPool(const Glib::ConstructParams& construct_params);
  explicit TaskPool(GstTaskPool* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
  virtual ~TaskPool();

#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type()      G_GNUC_CONST;


  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GObject.
  GstTaskPool*       gobj()       { return reinterpret_cast<GstTaskPool*>(gobject_); }

  ///Provides access to the underlying C GObject.
  const GstTaskPool* gobj() const { return reinterpret_cast<GstTaskPool*>(gobject_); }

  ///Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
  GstTaskPool* gobj_copy();

private:

  TaskPool();

public:
  /** For example,
   * void on_do_push();.
   */
  typedef sigc::slot<void> SlotPush;

public:
  /** Create a new default task pool. The default task pool will use a regular
   * Glib::ThreadPool for threads.
   * @return A new Gst::TaskPool.
   */
  
  static Glib::RefPtr<TaskPool> create();


  /** @throw Glib::Error.
   */
#ifdef GLIBMM_EXCEPTIONS_ENABLED
  void prepare();
#else
  void prepare(std::auto_ptr<Glib::Error>& error);
#endif //GLIBMM_EXCEPTIONS_ENABLED


  /** Start the execution of a new thread from pool.
   *
   * @param slot The function to call.
   * @return A pointer that should be used for the join() method. This pointer
   * can be 0, you must check error to detect errors.
   * @throw Glib::Error.
   */
#ifdef GLIBMM_EXCEPTIONS_ENABLED
  gpointer push(const SlotPush& slot);
#else
  gpointer push(const SlotPush& slot, std::auto_ptr<Glib::Error>& error);
#endif //GLIBMM_EXCEPTIONS_ENABLED
  

  /** Join a task and/or return it to the pool. @a id is the id obtained from 
   * push().
   * @param id The id.
   */
  void join(gpointer id);
  
  /** Wait for all tasks to be stopped. This is mainly used internally
   * to ensure proper cleanup of internal data structures in test suites.
   * 
   * MT safe.
   */
  void cleanup();

#ifdef GLIBMM_VFUNCS_ENABLED
  /** Virtual function which prepares the thread pool.
   * @throw Glib::Error.
   */
  #ifdef GLIBMM_EXCEPTIONS_ENABLED
  virtual void prepare_vfunc();
  #else
  virtual void prepare_vfunc(std::auto_ptr<Glib::Error>& error);
  #endif //GLIBMM_EXCEPTIONS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

  /** Virtual function to cleanup the thread pool.
   */
  #ifdef GLIBMM_VFUNCS_ENABLED
  virtual void cleanup_vfunc();
#endif //GLIBMM_VFUNCS_ENABLED


#ifdef GLIBMM_VFUNCS_ENABLED
  /** Virtual function which starts a new thread.
   * @throw Glib::Error.
   */
  #ifdef GLIBMM_EXCEPTIONS_ENABLED
  virtual gpointer push_vfunc(const SlotPush& slot);
  #else
  virtual gpointer push_vfunc(const SlotPush& slot,
    std::auto_ptr<Glib::Error>& error);
  #endif //GLIBMM_EXCEPTIONS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

  /** Virtual function to join a thread.
   */
  #ifdef GLIBMM_VFUNCS_ENABLED
  virtual void join_vfunc(gpointer id);
#endif //GLIBMM_VFUNCS_ENABLED


protected:

  
public:

public:
  //C++ methods used to invoke GTK+ virtual functions:
#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

protected:
  //GTK+ Virtual Functions (override these to change behaviour):
#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

  //Default Signal Handlers::
#ifdef GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED
#endif //GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED


};

} // namespace Gst


namespace Glib
{
  /** A Glib::wrap() method for this object.
   * 
   * @param object The C instance.
   * @param take_copy False if the result should take ownership of the C instance. True if it should take a new copy or ref.
   * @result A C++ instance that wraps this C instance.
   *
   * @relates Gst::TaskPool
   */
  Glib::RefPtr<Gst::TaskPool> wrap(GstTaskPool* object, bool take_copy = false);
}


#endif /* _GSTREAMERMM_TASKPOOL_H */

