// -*- c++ -*-
// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _GSTREAMERMM_TYPEFINDFACTORY_H
#define _GSTREAMERMM_TYPEFINDFACTORY_H


#include <glibmm.h>

/* gstreamermm - a C++ wrapper for gstreamer
 *
 * Copyright 2009 The gstreamermm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <gst/gsttypefindfactory.h>
#include <gstreamermm/pluginfeature.h>


#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _GstTypeFindFactory GstTypeFindFactory;
typedef struct _GstTypeFindFactoryClass GstTypeFindFactoryClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Gst
{ class TypeFindFactory_Class; } // namespace Gst
namespace Gst
{

class Caps;
class TypeFind;

/** Gst::TypeFindFactory — Information about registered typefind functions.
 * These functions allow querying informations about registered typefind
 * functions.
 *
 * Writing typefinders in C++ is not possible presently.
 *
 * Last reviewed on 2005-11-09 (0.9.4).
 */

class TypeFindFactory : public PluginFeature
{
  
#ifndef DOXYGEN_SHOULD_SKIP_THIS

public:
  typedef TypeFindFactory CppObjectType;
  typedef TypeFindFactory_Class CppClassType;
  typedef GstTypeFindFactory BaseObjectType;
  typedef GstTypeFindFactoryClass BaseClassType;

private:  friend class TypeFindFactory_Class;
  static CppClassType typefindfactory_class_;

private:
  // noncopyable
  TypeFindFactory(const TypeFindFactory&);
  TypeFindFactory& operator=(const TypeFindFactory&);

protected:
  explicit TypeFindFactory(const Glib::ConstructParams& construct_params);
  explicit TypeFindFactory(GstTypeFindFactory* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
  virtual ~TypeFindFactory();

#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type()      G_GNUC_CONST;


  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GObject.
  GstTypeFindFactory*       gobj()       { return reinterpret_cast<GstTypeFindFactory*>(gobject_); }

  ///Provides access to the underlying C GObject.
  const GstTypeFindFactory* gobj() const { return reinterpret_cast<GstTypeFindFactory*>(gobject_); }

  ///Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
  GstTypeFindFactory* gobj_copy();

private:


public:
 

  /** Gets the list of all registered typefind factories. You must free the
   * list using gst_plugin_feature_list_free.
   * @return The list of all registered Gst::TypeFindFactory.
   */
  static Glib::ListHandle< Glib::RefPtr<Gst::TypeFindFactory> > get_list();

 
  /** Gets the extensions associated with a Gst::TypeFindFactory. The returned
   * array should not be changed. If you need to change stuff in it, you should
   * copy it using Glib::stdupv().  This function may return <tt>0</tt> to indicate
   * a 0-length list.
   * @return A <tt>0</tt>-terminated array of extensions associated with this factory.
   */
  Glib::StringArrayHandle get_extensions() const;

  
  /** Gets the Gst::Caps associated with a typefind factory.
   * @return The Gst::Caps associated with this factory.
   */
  Glib::RefPtr<Gst::Caps> get_caps();
  
  /** Gets the Gst::Caps associated with a typefind factory.
   * @return The Gst::Caps associated with this factory.
   */
  Glib::RefPtr<const Gst::Caps> get_caps() const;
  
  /** Calls the Gst::TypeFind::SlotFind associated with this factory.
   * @param find A properly setup Gst::TypeFind entry. The get_data and suggest_type
   * members must be set.
   */
  void call_slot(Gst::TypeFind& find);


public:

public:
  //C++ methods used to invoke GTK+ virtual functions:
#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

protected:
  //GTK+ Virtual Functions (override these to change behaviour):
#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

  //Default Signal Handlers::
#ifdef GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED
#endif //GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED


};

} // namespace Gst


namespace Glib
{
  /** A Glib::wrap() method for this object.
   * 
   * @param object The C instance.
   * @param take_copy False if the result should take ownership of the C instance. True if it should take a new copy or ref.
   * @result A C++ instance that wraps this C instance.
   *
   * @relates Gst::TypeFindFactory
   */
  Glib::RefPtr<Gst::TypeFindFactory> wrap(GstTypeFindFactory* object, bool take_copy = false);
}


#endif /* _GSTREAMERMM_TYPEFINDFACTORY_H */

